
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Android CTS(frome google) / 憋错料</title>

    <meta name="description" content="Android CTS(frome google) Compatibility Test Suite How does the CTS work? The Compatibility Test Suite (CTS) is a free, commercial-grade test suite, available for download. The CTS represents the &quot;mechanism&quot; of compatibility. The CTS runs on a desktop machine and ex ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Android CTS(frome google)</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>Compatibility Test Suite</h1>

<h2>How does the CTS work?</h2>
<hr>
<br />The Compatibility Test Suite (CTS) is a free, commercial-grade test suite, available for&nbsp;<a href="http://source.android.com/compatibility/cts/downloads.html" rel="external nofollow noreferrer">download</a>. The CTS represents the "mechanism" of compatibility.</p>
<p>The CTS runs on a desktop machine and executes test cases directly on attached devices or an emulator. The CTS is a set of unit tests designed to be integrated into the daily workflow (such as via a continuous build system) of the engineers building a device. Its intent is to reveal incompatibilities early on, and ensure that the software remains compatible throughout the development process.</p>
<p>The CTS is an automated testing harness that includes two major software components:</p>
<ul>
<li>The CTS tradefed test harness runs on your desktop machine and manages test execution.</li>
<li>Individual test cases are executed on the Device Under Test (DUT). The test cases are written in Java as JUnit tests and packaged as Android .apk files to run on the actual device target.</li>
</ul>
<p>The Compatibility Test Suite Verifier (CTS Verifier) is a supplement to the CTS available for&nbsp;<a href="http://source.android.com/compatibility/cts/downloads.html" rel="external nofollow noreferrer">download</a>. CTS Verifier provides tests for APIs and functions that cannot be tested on a stationary device without manual input (e.g. audio quality, accelerometer, etc).</p>
<p>The CTS Verifier is a tool for manual testing and includes the following software components:</p>
<ul>
<li>The CTS verifier app that is executed on the DUT and collects the results.</li>
<li>The executable(s) or script(s) that are executed on the desktop machine to provide data or additional control for some test cases in the CTS Verifier app.</li>
</ul>
<h2>Workflow</h2>
<hr>
<br /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc291cmNlLmFuZHJvaWQuY29tL2NvbXBhdGliaWxpdHkvY3RzL2ltYWdlcy9jdHMtMC5wbmc=.jpg"></p>
<p><strong>Figure 1.</strong>&nbsp;How to use CTS</p>
<p>This diagram summarizes CTS workflow. Please refer to the subpages of this section starting with&nbsp;<a href="http://source.android.com/compatibility/cts/setup.html" rel="external nofollow noreferrer">Setup</a>&nbsp;for detailed instructions.</p>
<h2>Types of test cases</h2>
<hr>
<br />The CTS includes the following types of test cases:</p>
<ul>
<li><em>Unit tests</em>&nbsp;test atomic units of code within the Android platform; e.g. a single class, such as java.util.HashMap.</li>
<li><em>Functional tests</em>&nbsp;test a combination of APIs together in a higher-level use-case.</li>
</ul>
<p>Future versions of the CTS will include the following types of test cases:</p>
<ul>
<li><em>Robustness tests</em>&nbsp;test the durability of the system under stress.</li>
<li><em>Performance tests</em>&nbsp;test the performance of the system against defined benchmarks, for example rendering frames per second.</li>
</ul>
<h2>Areas covered</h2>
<hr>
<br />The unit test cases cover the following areas to ensure compatibility:</p>
<table>
<thead>
<tr>
<th>Area</th>
<th>Description</th>
</tr>
</thead>
<tbody>
<tr>
<td>Signature tests</td>
<td>For each Android release, there are XML files describing the signatures of all public APIs contained in the release. The CTS contains a utility to check those API signatures against the APIs available on the device. The results from signature checking are recorded in the test result XML file.</td>
</tr>
<tr>
<td>Platform API Tests</td>
<td>Test the platform (core libraries and Android Application Framework) APIs as documented in the SDK&nbsp;<a href="https://developer.android.com/reference/classes.html" rel="external nofollow noreferrer">Class Index</a>&nbsp;to ensure API correctness, including correct class, attribute and method signatures, correct method behavior, and negative tests to ensure expected behavior for incorrect parameter handling.</td>
</tr>
<tr>
<td>Dalvik Tests</td>
<td>The tests focus on testing the Dalvik Executable Format.</td>
</tr>
<tr>
<td>Platform Data Model</td>
<td>The CTS tests the core platform data model as exposed to application developers through content providers, as documented in the SDK&nbsp;<a href="https://developer.android.com/reference/android/provider/package-summary.html" rel="external nofollow noreferrer">android.provider</a>&nbsp;package: contacts, browser, settings, etc.</td>
</tr>
<tr>
<td>Platform Intents</td>
<td>The CTS tests the core platform intents, as documented in the SDK&nbsp;<a href="https://developer.android.com/guide/appendix/g-app-intents.html" rel="external nofollow noreferrer">Available Intents</a>.</td>
</tr>
<tr>
<td>Platform Permissions</td>
<td>The CTS tests the core platform permissions, as documented in the SDK&nbsp;<a href="https://developer.android.com/reference/android/Manifest.permission.html" rel="external nofollow noreferrer">Available Permissions</a>.</td>
</tr>
<tr>
<td>Platform Resources</td>
<td>The CTS tests for correct handling of the core platform resource types, as documented in the SDK&nbsp;<a href="https://developer.android.com/guide/topics/resources/available-resources.html" rel="external nofollow noreferrer">Available Resource Types</a>. This includes tests for: simple values, drawables, nine-patch, animations, layouts, styles and themes, and loading alternate resources.</td>
</tr>
</tbody>
</table>
<h1>Setting up CTS</h1>

<h2>Physical environment</h2>
<hr>
<h3>Wi-Fi and IPv6</h3>
<p>CTS tests require a Wi-Fi network that supports IPv6, can treat the Device Under Test (DUT) as an isolated client, and has an internet connection. An isolated client refers to a configuration where the DUT does not have visibility to the broadcast/multinetwork messages on that subnetwork, either by a Wi-Fi AP configuration or by running the DUT on an isolated sub-network without other devices being connected.</p>
<p>If you don‘t have access to a native IPv6 network, an IPv6 carrier network, or a VPN to pass some tests depending on IPv6, you may instead use a Wi-Fi access point and an IPv6 tunnel. See Wikipedia&nbsp;<a href="http://en.wikipedia.org/wiki/List_of_IPv6_tunnel_brokers" rel="external nofollow noreferrer">list of IPv6 tunnel brokers</a>.</p>
<h3>Bluetooth LE beacons</h3>
<p>If the DUT supports the Bluetooth LE feature, then at least three Bluetooth LE beacons should be placed within five meters of the DUT for Bluetooth LE scan testing. Those beacons can be any kind, do not need to be configured or emit anything specific, and can include iBeacon, Eddystone, or even devices simulating BLE beacons.</p>
<h2>Desktop machine setup</h2>
<hr>
<br />CTS currently supports 64-bit Linux and Mac OS host machines.</p>
<h3>ADB and AAPT</h3>
<p>Before running the CTS, make sure you have recent versions of both&nbsp;<a href="http://developer.android.com/tools/help/adb.html" rel="external nofollow noreferrer">Android Debug Bridge (adb)</a>&nbsp;and&nbsp;<a href="http://developer.android.com/guide/topics/manifest/uses-feature-element.html#testing" rel="external nofollow noreferrer">Android Asset Packaging Tool (AAPT)</a>&nbsp;installed and those tools‘ location added to the system path of your machine.</p>
<p>To install ADB, download the&nbsp;<a href="http://developer.android.com/sdk/index.html#Other" rel="external nofollow noreferrer">Android SDK Tools</a>&nbsp;package for your operating system, open it, and follow the instructions in the included README file. For troubleshooting information, see&nbsp;<a href="http://developer.android.com/sdk/installing/index.html?pkg=tools" rel="external nofollow noreferrer">Installing the Stand-alone SDK Tools</a>.</p>
<p>Ensure&nbsp;<code>adb</code>&nbsp;and&nbsp;<code>aapt</code>&nbsp;are in your system path. The following command assumes you‘ve opened the package archive in your home directory:</p>
<hr>
<pre>$ export PATH=$PATH:$HOME/android-sdk-linux/build-tools/&lt;version&gt;
</pre>
<p><strong>Note:</strong>&nbsp;Please ensure your starting path and directory name are correct.</p>
<h3>Java Development Kit (JDK)</h3>
<p>Install the proper version of the Java Development Kit (JDK). See the&nbsp;<a href="http://source.android.com/source/requirements.html#jdk" rel="external nofollow noreferrer">JDK requirements</a>.</p>
<h3>CTS files</h3>
<p><a href="http://source.android.com/compatibility/cts/downloads.html" rel="external nofollow noreferrer">Download</a>&nbsp;and open the CTS packages matching your devices‘ Android version and all the Application Binary Interfaces (ABIs) your devices support.</p>
<p>Download and open the latest version of the&nbsp;<a href="http://source.android.com/compatibility/cts/downloads.html#cts-media-files" rel="external nofollow noreferrer">CTS Media Files</a>.</p>
<h3>Device detection</h3>
<p>Follow the step to&nbsp;<a href="http://developer.android.com/tools/device.html#setting-up" rel="external nofollow noreferrer">set up your system to detect your device</a>, such as creating a&nbsp;<code>udev</code>&nbsp;rules file for Ubuntu Linux.</p>
<h2>Android device setup</h2>
<hr>
<h3>User builds</h3>
<p>A compatible device is defined as a device with a user/release-key signed build, so your device should be running a system image based on the known to be compatible user build (Android 4.0 and later) from&nbsp;<a href="http://source.android.com/source/build-numbers.html" rel="external nofollow noreferrer">Codenames, Tags, and Build Numbers</a>.</p>
<p><strong>Caution:</strong>&nbsp;When used to confirm Android compatibility of your final system image, CTS must be executed on devices with a user build.</p>
<h3>Storage requirements</h3>
<p>The CTS media stress tests require video clips to be on external storage (<code>/sdcard</code>). Most of the clips are from&nbsp;<a href="https://peach.blender.org/" rel="external nofollow noreferrer">Big Buck Bunny</a>&nbsp;which is copyrighted by the Blender Foundation under the&nbsp;<a href="http://creativecommons.org/licenses/by/3.0/" rel="external nofollow noreferrer">Creative Commons Attribution 3.0 license.</a></p>
<p>The required space depends on the maximum video playback resolution supported by the device (See section 5 in the compatibility definition document for the platform version of the required resolutions.) Note that the video playback capabilities of the device under test will be checked via the&nbsp;<code>android.media.CamcorderProfile</code>&nbsp;APIs for earlier versions of Android and the&nbsp;<code>android.media.MediaCodecInfo.CodecCapabilities</code>&nbsp;APIs from Android 5.0.</p>
<p>Here are the storage requirements by maximum video playback resolution:</p>
<ul>
<li>480x360: 98MB</li>
<li>720x480: 193MB</li>
<li>1280x720: 606MB</li>
<li>1920x1080: 1863MB</li>
</ul>
<h3>Screen and storage</h3>
<ol>
<li>Any device that does not have an embedded screen needs to be connected to a screen.</li>
<li>If the device has a memory card slot, plug in an empty SD card.&nbsp;<em>Use an SD card that supports Ultra High Speed (UHS) Bus with SDHC or SDXC capacity or one with at least speed class 10 or higher to ensure it can pass the CTS.</em><br />
<br /><strong>Warning:</strong>&nbsp;CTS may modify/erase data on the SD card plugged into the device.</li>
<li>If the device has SIM card slots, plug in an activated SIM card to each slot. If the device supports SMS, each SIM card should have its own number field populated.</li>
</ol>
<h3>Developer UICC</h3>
<p>In order to run CTS carrier API tests, the device needs to has a SIM card with carrier privilege rules on it. See<a href="http://source.android.com/devices/tech/config/uicc.html#prepare_uicc" rel="external nofollow noreferrer">Preparing the UICC</a>.</p>
<h2>Android device configuration</h2>
<hr>
<ol>
<li>Factory data reset the device:&nbsp;<strong>Settings &gt; Backup &amp; reset &gt; Factory data reset</strong></p>
<p><strong>Warning:</strong>&nbsp;This will erase all user data from the device.</li>
<li>Set your device‘s language to English (<strong>United States</strong>) from:&nbsp;<strong>Settings &gt; Language &amp; input &gt; Language</strong></li>
<li>Turn on the location setting if there is a GPS or Wi-Fi / Cellular network feature on the device:&nbsp;<strong>Settings &gt; Location &gt; On</strong></li>
<li>Connect to a Wi-Fi network that supports IPv6, can treat the Device Under Test (DUT) as an&nbsp;<em>isolated client</em>&nbsp;(see the&nbsp;<a href="http://source.android.com/compatibility/cts/setup.html#physical_environment" rel="external nofollow noreferrer">Physical Environment</a>&nbsp;section above), and has an internet connection:&nbsp;<strong>Settings &gt; Wi-Fi</strong></li>
<li>Make sure no lock pattern or password is set on the device:&nbsp;<strong>Settings &gt; Security &gt; Screen lock &gt; None</strong></li>
<li>Enable&nbsp;<strong>USB debugging</strong>&nbsp;on your device:&nbsp;<strong>Settings &gt; Developer options &gt; USB debugging</strong>.<br />
<br /><strong>Note:</strong>&nbsp;On Android 4.2 and later,&nbsp;<strong>Developer options</strong>&nbsp;is hidden by default. To make them available, go to<strong>Settings &gt; About phone</strong>&nbsp;and tap&nbsp;<strong>Build number</strong>&nbsp;seven times. Return to the previous screen to find&nbsp;<strong>Developer options</strong>. See&nbsp;<a href="http://developer.android.com/tools/device.html#developer-device-options" rel="external nofollow noreferrer">Enabling On-device Developer Options</a>&nbsp;for additional details.</li>
<li>Select:&nbsp;<strong>Settings &gt; Developer options &gt; Stay Awake &gt; On</strong></li>
<li>Select:&nbsp;<strong>Settings &gt; Developer options &gt; Allow mock locations &gt; On</strong><br />
<br /><strong>Note:</strong>&nbsp;This mock locations setting is applicable only in Android 5.x and 4.4.x.</li>
<li>Select:&nbsp;<strong>Settings &gt; Developer options &gt; Verify apps over USB &gt; Off</strong><br />
<br /><strong>Note:</strong>&nbsp;This verify apps step became required in Android 4.2.</li>
<li>Launch the browser and dismiss any startup/setup screen.</li>
<li>Connect the desktop machine that will be used to test the device with a USB cable<br />
<br /><strong>Note:</strong>&nbsp;When you connect a device running Android 4.2.2 or later to your computer, the system shows a dialog asking whether to accept an RSA key that allows debugging through this computer. Select&nbsp;<em>Allow USB debugging</em>.</li>
<li>Install and configure helper apps on the device.<br />
<br /><strong>Note:</strong>&nbsp;For CTS versions 2.1 R2 through 4.2 R4, set up your device (or emulator) to run the accessibility tests with:<br /><code>adb install -r android-cts/repository/testcases/CtsDelegatingAccessibilityService.apk</code><br />On the device, enable:&nbsp;<strong>Settings &gt; Accessibility &gt; Accessibility &gt; Delegating Accessibility Service</strong></p>
<p><strong>Note:</strong>&nbsp;For CTS 2.3 R4 through CTS 6.0 on devices that declare the&nbsp;<code>android.software.device_admin feature</code>, set up your device to run the device administration tests with:<br /><code>adb install -r android-cts/repository/testcases/CtsDeviceAdmin.apk</code><br />On the device, enable only the two&nbsp;<code>android.deviceadmin.cts.CtsDeviceAdminReceiver*</code>&nbsp;device administrators under:&nbsp;<strong>Settings &gt; Security &gt; Select device administrators</strong>. Make sure the<code>android.deviceadmin.cts.CtsDeviceAdminDeactivatedReceiver</code>&nbsp;and any other preloaded device administrators stay disabled in the same menu.</li>
<li>Copy the CTS media files to the device as follows:<br />
<br /><strong>Note:</strong>&nbsp;For CTS 2.3 R12 and beyond, if the device supports video codecs, the CTS media files must be copied to the device.</p>
<ul>
<li>Navigate (cd) to the path the media files are downloaded and unzipped to.</li>
<li>Change the file permissions:&nbsp;<code>chmod u+x copy_media.sh</code></li>
<li>Run&nbsp;<code>copy_media.sh</code>:
<ul>
<li>To copy clips up to a resolution of 720x480, run:&nbsp;<code>./copy_media.sh 720x480</code></li>
<li>If you are not sure about the maximum resolution, try&nbsp;<code>./copy_media.sh all</code>&nbsp;so that all files are copied.</li>
<li>If there are multiple devices under adb, add the -s (serial) option to the end. For example, to copy up to 720x480 to the device with serial 1234567, run:&nbsp;<code>./copy_media.sh 720x480 -s 1234567</code></li>
</ul>
</li>
</ul>
</li>
</ol>
<h1>Running CTS tests</h1>
<h2>Getting started with CTS tradefed</h2>
<hr>
<br />See the&nbsp;<a href="http://source.android.com/devices/tech/test_infra/tradefed/index.html" rel="external nofollow noreferrer">Trade Federation Overview</a>&nbsp;for an explanation of the Trade Federation (tradefed or TF for short) continuous test framework.</p>
<p>To run a test plan:</p>
<ol>
<li>Connect at least one device.</li>
<li>Press the&nbsp;<strong>home</strong>&nbsp;button to set the device to the home screen at the start of CTS.</li>
<li>While a device is running tests, it must not be used for any other tasks and must be kept in a stationary position (to avoid triggering sensor activity) with the cameras pointing at an object that could be focused.</li>
<li>Do not press any keys on the device while the CTS is running. Pressing keys or touching the screen of a test device will interfere with the running tests and may lead to test failures.</li>
<li>Launch the CTS console by running the&nbsp;<em>cts-tradefed</em>&nbsp;script from the folder where the CTS package has been unzipped, e.g.&nbsp;<code>$ ./android-cts/tools/cts-tradefed</code></li>
<li>You may start the default test plan (containing all of the test packages) by appending:&nbsp;<code>run cts --plan CTS</code>&nbsp;(or just&nbsp;<code>run cts</code>&nbsp;for v2). This kicks off all the CTS tests required for compatibility. Enter&nbsp;<code>list plans</code>&nbsp;to see a list of test plans in the repository. Enter&nbsp;<code>list packages</code>&nbsp;to see a list of test packages in the repository. See the CTS command reference or type help for a complete list of supported commands.</li>
<li>Alternately, you may run the CTS plan of your choosing from the command line using:&nbsp;<code>cts-tradefed run cts --plan&lt;plan_name&gt;</code><br />
<br /><strong>Note:</strong>&nbsp;When running Android 6.0 (Marshmallow) CTS only, we recommend you use the&nbsp;<code>--skip-preconditions</code>option to skip the experimental pre-conditions feature that may cause issues for when executing CTS tests.</li>
<li>View test progress and results reported on the console.</li>
<li>If your device is Android 5.0 or later and declares support for an ARM and a x86 ABI, you should run both the ARM and x86 CTS packages.</li>
</ol>
<h2>Using the CTS v1 console</h2>
<hr>
<br />For Android 6.0 or earlier, you‘ll use CTS v1.</p>
<h3>Selecting plans</h3>
<p>The following test plans are available:</p>
<ul>
<li><em>CTS</em>—all tests required for compatibility.</li>
<li><em>Signature</em>—the signature verification of all public APIs</li>
<li><em>Android</em>—tests for the Android APIs</li>
<li><em>Java</em>—tests for the Java core library</li>
<li><em>VM</em>—tests for ART or Dalvik</li>
<li><em>Performance</em>—performance tests for your implementation</li>
</ul>
<p>These can be executed with the&nbsp;<code>run cts</code>&nbsp;command.</p>
<h3>CTS v1 console command reference</h3>
<p><strong>Table 1.</strong>&nbsp;This table summarizes the CTS v1 console commands for various uses.</p>
<table>
<tbody>
<tr>
<th>Host</th>
<th>Description</th>
</tr>
<tr>
<td><code>help</code></td>
<td>Display a summary of the most commonly used commands</td>
</tr>
<tr>
<td><code>help all</code></td>
<td>Display the complete list of available commands</td>
</tr>
<tr>
<td><code>exit</code></td>
<td>Gracefully exit the CTS console. Console will close when all currently running tests are finished</td>
</tr>
<tr>
<th>Run</th>
<th>Description</th>
</tr>
<tr>
<td><code>run cts</code></td>
<td>Run the specified tests and displays progress information. One of&nbsp;<code>--plan</code>,&nbsp;<code>--package</code>,&nbsp;<code>--class</code>&nbsp;or&nbsp;<code>--continue-session</code>&nbsp;needs to be specified</p>
<p>The CTS console can accept other commands while tests are in progress</p>
<p>If no devices are connected, the CTS desktop machine (or host) will wait for a device to be connected before starting tests</p>
<p>If more than one device is connected, the CTS host will choose a device automatically</p>
</td>
</tr>
<tr>
<td><code>--plan &lt;test_plan_name&gt;</code></td>
<td>Run the specified test plan</td>
</tr>
<tr>
<td><code>--package/-p &lt;test_package_name&gt; &nbsp;[--package/-p &lt;test_package2&gt;...]</code></td>
<td>Run the specified test packages</td>
</tr>
<tr>
<td><code>--class/-c &lt;class_name&gt; [--method/-m &lt;test_method_name&gt;</code></td>
<td>Run the specified test class and/or method</td>
</tr>
<tr>
<td><code>--continue-session</code></td>
<td>Run all not executed tests from previous CTS session; the sessions testResult.xml will be updated with the new results</td>
</tr>
<tr>
<td><code>--shards&nbsp;&lt;number_of_shards&gt;</code></td>
<td>Shard a CTS run into given number of independent chunks, to run on multiple devices in parallel</td>
</tr>
<tr>
<td><code>--serial/-s &lt;deviceID&gt;</code></td>
<td>Run CTS on the specific device</td>
</tr>
<tr>
<td><code>-t &lt;class_name&gt;#&lt;test_method_name&gt;</code></td>
<td>Run a specific test method</td>
</tr>
<tr>
<td><code>--force-abi 32|64</code></td>
<td>On 64-bit devices, run the test against only the 32-bit or 64-bit ABI</td>
</tr>
<tr>
<th>List</th>
<th>Description</th>
</tr>
<tr>
<td><code>list packages</code></td>
<td>List all available test packages in the repository</td>
</tr>
<tr>
<td><code>list plans</code></td>
<td>List all available test plans in the repository</td>
</tr>
<tr>
<td><code>list invocations</code></td>
<td>List ‘run‘ commands currently being executed on devices</td>
</tr>
<tr>
<td><code>list commands</code></td>
<td>List all ‘run‘ commands currently in the queue waiting to be assigned to devices</td>
</tr>
<tr>
<td><code>list results</code></td>
<td>List CTS results currently stored in repository</td>
</tr>
<tr>
<td><code>list devices</code></td>
<td>List currently connected devices and their state</p>
<p>‘Available‘ devices are functioning, idle devices, available for running tests</p>
<p>‘Unavailable‘ devices are devices visible via adb, but are not responding to adb commands and won‘t be allocated for tests</p>
<p>‘Allocated‘ devices are devices currently running tests</p>
</td>
</tr>
<tr>
<th>Add</th>
<th>Description</th>
</tr>
<tr>
<td><code>add derivedplan --plan &lt;plan_name&gt;<br />--result/-r<br />[pass | fail | timeout | notExecuted]<br />[--session/-s &lt;session_id&gt;]</code></td>
<td>Create a plan derived from given result session; use this option to rerun reports and validate test issues</td>
</tr>
</tbody>
</table>
<h2>Using the CTS v2 console</h2>
<hr>
<br />For Android 7.0 or later, you‘ll use CTS v2.</p>
<h3>Selecting plans</h3>
<p>Available test plans include the following:</p>
<ul>
<li><em>cts</em>—Runs CTS from an pre-existing CTS installation.</li>
<li><em>cts-camera</em>— Runs CTS-camera from a pre-existing CTS installation.</li>
<li><em>cts-java</em>— Runs Core Java Tests from a pre-existing CTS installation.</li>
<li><em>cts-pdk</em>— Runs Tests useful on validating a PDK fusion build.</li>
<li><em>everything</em>— Common config for Compatibility suites.</li>
</ul>
<p>Other available configurations include the following:</p>
<ul>
<li><em>basic-reporters</em>— Configuration with basic CTS reporters.</li>
<li><em>collect-tests-only</em>—Runs CTS from a pre-existing CTS installation.</li>
<li><em>common-compatibility-config</em>— Common config for Compatibility suites.</li>
<li><em>cts-filtered-sample</em>— Common config for Compatibility suites.</li>
<li><em>cts-known-failures</em>— Configuration with CTS known failures.</li>
<li><em>cts-preconditions</em>— CTS precondition configs.</li>
<li><em>host</em>— Runs a single host-based test on an existing device.</li>
<li><em>instrument</em>— Runs a single Android instrumentation test on an existing device.</li>
<li><em>native-benchmark</em>— Runs a native stress test on an existing device.</li>
<li><em>native-stress</em>— Runs a native stress test on an existing device.</li>
<li><em>recharge</em>— A fake test that waits for nearly-discharged devices and holds them for charging.</li>
<li><em>testdef</em>— Runs tests contained in test_def.xml files on an existing device.</li>
<li><em>util/wifi</em>— Utility config to configure Wi-Fi on device.</li>
<li><em>util/wipe</em>— Wipes user data on device.</li>
</ul>
<p>All of these plans and configs can be executed with the&nbsp;<code>run cts</code>&nbsp;command.</p>
<h3>CTS v2 console command reference</h3>
<p><strong>Table 1.</strong>&nbsp;This table summarizes the CTS V2 console commands for various uses.</p>
<table>
<tbody>
<tr>
<th>Host</th>
<th>Description</th>
</tr>
<tr>
<td><code>help</code></td>
<td>Display a summary of the most commonly used commands</td>
</tr>
<tr>
<td><code>help all</code></td>
<td>Display the complete list of available commands</td>
</tr>
<tr>
<td><code>version</code></td>
<td>Show the version.</td>
</tr>
<tr>
<td><code>exit</code></td>
<td>Gracefully exit the CTS console. Console will close when all currently running tests are finished.</td>
</tr>
<tr>
<th>Run</th>
<th>Description</th>
</tr>
<tr>
<td><code>run cts</code></td>
<td>
<br />Run the default CTS plan (that is, the full CTS invocation).</p>
<p>The CTS console can accept other commands while tests are in progress.</p>
<p>If no devices are connected, the CTS desktop machine (or host) will wait for a device to be connected before starting tests.</p>
<p>If more than one device is connected, the CTS host will choose a device automatically.</p>
</td>
</tr>
<tr>
<td><code>--plan &lt;test_plan_name&gt;</code></td>
<td>Run the specified test plan.</td>
</tr>
<tr>
<td><code>-- module/-m &lt;test_module_name&gt; &nbsp;[--module/-m &lt;test_module2&gt;...]</code></td>
<td>Run the specified test module or modules. For example,&nbsp;<code>run cts --module CtsGestureTestCases</code>&nbsp;executes the gesture test module (this can be shortened to&nbsp;<code>run cts -m Gesture</code>).<br /><code>run cts -m Gesture --test android.gesture.cts.GestureTest#testGetStrokes</code>&nbsp;runs the specific package, class, or test.</td>
</tr>
<tr>
<td><code>-- module/-m &lt;test_module_name&gt; -- test &lt;test_name&gt;&nbsp;</code></td>
<td>Run the specified module and test. For example,&nbsp;<code>run cts -m Gesture --test android.gesture.cts.GestureTest#testGetStrokes</code>&nbsp;runs the specific package, class, or test.</td>
</tr>
<tr>
<td><code>--retry</code></td>
<td>Retry all tests that failed or were not executed from the previous sessions. Use&nbsp;<code>list results</code>&nbsp;to get the session id.</td>
</tr>
<tr>
<td><code>--shards&nbsp;&lt;number_of_shards&gt;</code></td>
<td>Shard a CTS run into given number of independent chunks, to run on multiple devices in parallel.</td>
</tr>
<tr>
<td><code>--serial/-s &lt;deviceID&gt;</code></td>
<td>Run CTS on the specific device.</td>
</tr>
<tr>
<td><code>--include-filter &lt;module_name&gt; &nbsp;[--include-filter &lt;module2&gt;...]</code></td>
<td>Run only with the specified modules.</td>
</tr>
<tr>
<td><code>--exclude-filter &lt;module_name&gt; &nbsp;[--exclude-filter &lt;module2&gt;...]</code></td>
<td>Exclude the specified modules from the run.</td>
</tr>
<tr>
<td><code>--log-level-display/-l &lt;log_level&gt;</code></td>
<td>Run with the minimum specified log level displayed to STDOUT. Valid values: [VERBOSE, DEBUG, INFO, WARN, ERROR, ASSERT].</td>
</tr>
<tr>
<td><code>--abi &lt;abi_name&gt;</code></td>
<td>Force the test to run on the given ABI, 32 or 64. By default CTS runs a test once for each ABI the device supports.</td>
</tr>
<tr>
<td><code>--logcat</code>,&nbsp;<code>--bugreport</code>, and&nbsp;<code>--screenshoot-on-failure</code></td>
<td>Give more visibility into failures and can help with diagnostics.</td>
</tr>
<tr>
<td><code>--device-token</code></td>
<td>Specifies a given device has the given token eg.&nbsp;<code>--device-token 1a2b3c4d:sim-card.</code>.</td>
</tr>
<tr>
<td><code>--skip-device-info</code></td>
<td>Skips collection of information about the device. Note: do not use this option when running CTS for approval.</td>
</tr>
<tr>
<td><code>--skip-preconditions</code></td>
<td>Bypasses verification and setup of the device‘s configuration, such as pushing media files or checking for Wi-Fi connection.</td>
</tr>
<tr>
<th>List</th>
<th>Description</th>
</tr>
<tr>
<td><code>list modules</code></td>
<td>List all available test modules in the repository.</td>
</tr>
<tr>
<td><code>list plans</code>&nbsp;or&nbsp;<code>list configs</code></td>
<td>List all available test plans (configs) in the repository.</td>
</tr>
<tr>
<td><code>list invocations</code></td>
<td>List ‘run‘ commands currently being executed on devices.</td>
</tr>
<tr>
<td><code>list commands</code></td>
<td>List all ‘run‘ commands currently in the queue waiting to be assigned to devices.</td>
</tr>
<tr>
<td><code>list results</code></td>
<td>List CTS results currently stored in repository.</td>
</tr>
<tr>
<td><code>list devices</code></td>
<td>List currently connected devices and their state.</p>
<p>‘Available‘ devices are functioning, idle devices, available for running tests.</p>
<p>‘Unavailable‘ devices are devices visible via adb, but are not responding to adb commands and won‘t be allocated for tests.</p>
<p>‘Allocated‘ devices are devices currently running tests.</p>
</td>
</tr>
<tr>
<th>Dump</th>
<th>Description</th>
</tr>
<tr>
<td><code>dump logs</code></td>
<td>Dump the tradefed logs for all running invocations.</td>
</tr>
</tbody>
</table>
<h1>Interpreting CTS results</h1>
<p>The CTS test results are placed in the file:</p>
<pre>$CTS_ROOT/android-cts/repository/results/&lt;start_time&gt;.zip</pre>
<p>If you have built the CTS yourself,&nbsp;<em>$CTS_ROOT</em>&nbsp;will resemble the path&nbsp;<em>out/host/linux-x86/cts</em>&nbsp;but differ by platform. This reflects the path where you have uncompressed the prebuilt official CTS&nbsp;<a href="http://source.android.com/compatibility/cts/downloads.html" rel="external nofollow noreferrer">downloaded</a>&nbsp;from this site.</p>
<p>Inside the zip, the testResult.xml file contains the actual results—open this file in any web browser (HTML5 compatible browser recommended) to view the test results. It will resemble the following screenshots.</p>
<p><strong>Note:</strong>&nbsp;The results are provided to help you ensure the software remains compatible throughout the development process and act as a common format for communicating the compatibility status of your device with other parties.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc291cmNlLmFuZHJvaWQuY29tL2NvbXBhdGliaWxpdHkvY3RzL2ltYWdlcy9jdHMtdGVzdC1zdW1tYXJ5LnBuZw==.jpg"></p>
<p><strong>Figure 1.</strong>&nbsp;CTS test summary</p>
<p>If testResult.xml displays a blank page when using the Chrome browser,&nbsp;<a href="https://www.chromium.org/developers/how-tos/run-chromium-with-flags" rel="external nofollow noreferrer">change your browser configuration</a>&nbsp;to enable the&nbsp;<em>--allow-file-access-from-files</em>&nbsp;command line flag.</p>
<p>The Device Information section provides details about the device, firmware (make, model, firmware build, platform), and device hardware (screen resolution, keypad, screen type). To access device information, click the link above Test Summary.</p>
<p>The&nbsp;<em>Test Summary</em>&nbsp;section provides executed test plan details, like the CTS plan name and execution start and end times. It also presents an aggregate summary of the number of tests that passed, failed, timed out, or could not be executed.</p>
<p>The next section also provides a summary of tests passed per package.</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvc291cmNlLmFuZHJvaWQuY29tL2NvbXBhdGliaWxpdHkvY3RzL2ltYWdlcy9jdHMtdGVzdC1yZXBvcnQucG5n.jpg"></p>
<p><strong>Figure 2.</strong>&nbsp;CTS test report</p>
<p>This is followed by details of the the actual tests that were executed. The report lists the test package, test suite, test case, and the executed tests. It shows the result of the test execution—pass, fail, timed out, or not executed. In the event of a test failure details are provided to help diagnose the cause.</p>
<p>Further, the stack trace of the failure is available in the XML file but is not included in the report to ensure brevity—viewing the XML file with a text editor should provide details of the test failure (search for the&nbsp;<em>&lt;Test&gt;</em>&nbsp;tag corresponding to the failed test and look within it for the&nbsp;<em>&lt;StackTrace&gt;</em>&nbsp;tag).</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-06 03:51:31 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Android CTS(frome google)的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPdgBvM.html" rel="bookmark">Android CTS</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.什么是CTS CTS是google制定的兼容性测试包(Compatibility Test Suite),只有通过CTS测试的设备才有可能获得Android的商标和享受Android Market的权限.其目的是用来规范Android设备开发商防止厂商对Android的改动影响其SDK API的兼容性,确保设备运行的Android系统全面兼容Android规范,即第三方应用程序安装到该厂商的机器上都能正常运行,给用户带来更好的体验.Google还提供了一份兼容性标准文档(Compatibil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4ARNlzM.html" rel="bookmark">Android CTS（兼容性测试）整个流程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				为了保证开发的应用在所有兼容Android的设备上正常运行,并保证一致的用户体验,Google制定了CTS(Compatibility Test Suite)来确保设备运行的Android系统全面兼容Android规范,Google也提供了一份兼容性标准文档(Compatibility Definition Document, CDD). 在进行CTS之前,需要先从google官网下载相关文件,需要自卑梯子翻墙.下载链接: http://source.android.com/compatibil			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nYRXKM.html" rel="bookmark">Android CTS測试Fail项改动总结（四）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android5.1上的測试 1.android.security.cts.SELinuxDomainTest# testInitDomain fail 打印的log junit.framework.AssertionFailedError: Expected 1 process in SELinux domain &quot;u:r:init:s0&quot; Found &quot;[ pid: &quot;1&quot; proctitle: &quot;/init&quot; label: &qu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rbrOg3.html" rel="bookmark">Android CTS Test</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是CTS测试?了解这个问题前,我们先来搜索了解一遍&quot;Google GMS 认证&quot;.GMS全称为GoogleMobile Service,即谷歌移动服务.说白了GMS其实就是一系列谷歌的应用集合.谷歌GMS认证(Google Mobile Services Test Certification )是谷歌公司为了确保全世界的硬件厂商设计和生产安卓为基础的各种智能硬件产品的兼容性.稳定性,以及这些硬件与安卓各种自带的各种软件APP产品和服务的兼容性.稳定性方面的测试和认证. Google			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35Xl9n0.html" rel="bookmark">监听Android CTS测试项解决方案（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言: 首先这里需要详细叙述一下标题中&quot;监听Android CTS测试项解决方案&quot;的需求.这里的需求是指我们需要精确的监听到当前CTS测试正在测试的测试项. 因为我们知道CTS认证是获得Google推出的 Android 系统中 Android Market 服务的前提.CTS 兼容性测试的主要目的和意义在于使得用户在 Android 系统的应用过程中,有更好的用户体验,并展现出 Android 系统的优越特性:使得 Android 应用程序编写者更容易编写高质量的应用程序:充分展现			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lGZlXM.html" rel="bookmark">Android SDK Manager Google Apis 下载</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本意是想利用google的gcm来实装android推送功能的,很遗憾, google貌似已经停止提供啥服务给国内了,或者说国内想继续使用google 服务暂时变得几乎不可能了.找了个代理来进行google adt的下载之后, 打开里面的sdk manager,发现竟然找了好久的google apis就在下载一览 里面.很激动的去点击下载,结果,每次都下载失败.超时呀什么的乱七八糟 的错误.这里发现,原来sdk manager同大部分网络应用一样,使用的是tcp/ip 协议,而我的代理是http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLxRpdM.html" rel="bookmark">Android CTS 测试总结【转】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近一直在做Android兼容性测试,根据Android官网给出的android-cts-manual 配置好了device后,开始测试. 首先配置软件环境: 1.下载Android-2.1系统,并编译. $ . build/envsetup.sh          //配置选项,并编译android源码$ make cts                                 //android源码编译好后,在编译cts 2.编译好cts后生成的文件位置如下 #mydroid/out			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MBDV6q3.html" rel="bookmark">Android性能优化Google课程翻译一&colon;Render----OverDraw实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Context 最近实战了下OverDraw,加深了下理解.在上篇文章里Android性能优化Google课程翻译一:Render----OverDraw 写过具体方法. OverDraw解决方法离不开View,给我的感觉好像是加了层View就会加一层.但本质上如名字OverDraw,还是和Draw有关系,和几层View没关系.如下实例: Button 如下图, 书架和书城是一个Button,然后我把书架的Button findViewById(R.id.main_jump_shelf).set			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eYexg0.html" rel="bookmark">Android开发工具&mdash;&mdash;Google发布Android studio1&period;0正式版</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android Studio介绍 Android Studio是一个为Android平台开发程序的集成开发环境.2013年5月16日由Google产品经理Ellie Powers在Google I/O上发布,可供开发者免费使用.2013年5月发布早期预览版本,版本号为0.1.2014年6月发布0.8版本,至此进入beta阶段.第一个稳定版本于2014年12月8日发布.Android Studio基于JetBrains IntelliJ IDEA,为Android开发特殊定制,并在Windows.			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/NMyNBL0.html" rel="bookmark" class="title">CNN卷积神经网络新想法</a>
					<div>
						最近一直在看卷积神经网络,想改进改进弄出点新东西来,看了好多论文,写了一篇综述,对深度学习中卷积神经网络有了一些新认识,和大家分享下. 其实卷积神经网络并不是一项新兴的算法,早在上世纪八十年代就已经被 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xOYBM.html" rel="bookmark" class="title">PHP入门（16） 使用mysqli实现简单的分页</a>
					<div>
						前几天正好学习了如何使用PHP自带的api操作MySQL数据库,正好拿一下分页这个小案例练一下手. 关于分页的算法有很多,这里仅仅介绍很简单的一种. 分页的原理: 首先获得总共含有多少行$row_nu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KaNLm4.html" rel="bookmark" class="title">&lowbar;&lowbar;newindex元方法</a>
					<div>
						__index元方法是访问,如果表中没有就会进元方法查找(如果有元表的话),如果元方法是表,返回元表的元素:如果元方法是函数,则返回函数的返回值 __newindex元方法就是赋值,如果元表定义了这个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dxvwg0.html" rel="bookmark" class="title">Struts&lpar;六&rpar;</a>
					<div>
						JSON(JavaScript Object Notation)    1.一种轻量级的数据交换格式    2.通常用于在客户端和服务器之间传递数据    3.jQuery的所有参数都是以JSON格式 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KyVRJ4.html" rel="bookmark" class="title">mysql多实例配置文件</a>
					<div>
						#++++++++++++++++++++++++++++++++ multi ++++++++++++++++++++++++++ [mysqld_multi] mysqld = /usr/loca ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0Kqjpj4.html" rel="bookmark" class="title">总结 iOS中一些常用的小方法</a>
					<div>
						一.改变状态栏的颜色: (1).在项目 Info plist 里面添加:View controller-based status bar appearance 设置为 NO (2).在项目的BaseV ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MElppR4.html" rel="bookmark" class="title">Java&lowbar;1&lowbar;初识&lowbar;基本数据类型与数组</a>
					<div>
						Java的基本数据类型按精度级别由低到高: byte  short  char  int  long  float  double 实验一: 数据之间的转换:char和int(输出希腊字母表) pub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo5aZn3.html" rel="bookmark" class="title">POJ 1655 Balancing Act（树的重心）</a>
					<div>
						Balancing Act Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 14062   Accepted: 5937 De ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MD8rDKM.html" rel="bookmark" class="title">给一段文字设置不同颜色</a>
					<div>
						做项目时候遇到这个需求了,就是一个NSString,设置不同颜色. 例如:给一段文字设置不同颜色 用到NSString一个方法: - (void)addAttribute:(NSString *)na ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xaqWn3.html" rel="bookmark" class="title">安卓通知控件SnackBar详解</a>
					<div>
						安卓开发中常用的控件包括Toast和Dilalog,本文和大家分享则是通知控件SnackBar相关使用,一起来看看吧. Dilalog Dialog的作用是给用户一个提示信息,并让用户根据提示做出判断 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME6e610.html" rel="bookmark" class="title">Entity Framework基础01</a>
					<div>
						学习了ADO.NET的相关知识,掌握了它对数据库表的基本操作,但是实际在开发项目应用中微软为我们开发ef这个ORM,使用它可以很方便的利用ADO.NET来操作DBMS,使得我们开发项目的着重点放在业务 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyoQRj3.html" rel="bookmark" class="title">mysql linux 备份脚本</a>
					<div>
						#!/bin/sh # mysql data backup script # # use mysqldump --help,get more detail. # BakDir=/root/back/m ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzkYlA0.html" rel="bookmark" class="title">java多线程并发（一）&mdash;&mdash;Semaphore，volatile，synchronized ，Lock</a>
					<div>
						在并发编程中,我们通常会遇到以下三个问题:原子性问题,可见性问题,有序性问题.我们先看具体看一下这三个概念: 1.原子性 原子性:即一个操作或者多个操作 要么全部执行并且执行的过程不会被任何因素打断, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6XK8N3.html" rel="bookmark" class="title">java类的封装 继承 多态</a>
					<div>
						1.猜数字小游戏 package cn.jiemoxiaodi_02; import java.util.Scanner; /** * 猜数字小游戏 * * @author huli * */ pub ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lD7Jo0.html" rel="bookmark" class="title">操作系统内存配置overcommit&lowbar;memory</a>
					<div>
						操作系统内存配置overcommit_memory 问题描述: 在安装Redis时,会得到如下警告: # WARNING overcommit_memory is set to 0! Backgrou ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXYdPM.html" rel="bookmark" class="title">VS更改项目名称</a>
					<div>
						假设原项目名称为A,要更改为B 1.将文件夹A,A/A,修改为B,B/B 2.将A/A中的Avcxproj修改为B.vcxproj A.vcxproj.filters改为B.vcxproj.filte ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXGGr84.html" rel="bookmark" class="title">JS使用canvas操作、压缩图片</a>
					<div>
						1.使用input标签添加图片文件. &lt;input type=&quot;file&quot; name=&quot;upload_photo&quot; id=&quot;upload_pho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myz1Jj0.html" rel="bookmark" class="title">java 动态代理的学习详解</a>
					<div>
						再讲java动态代理前,先来看看代理模式. Proxy类通过组合,对Hello类进行了增强,并对其进行了委托. 代理模式代码: public class ProxyPattern { interfac ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j87JE4.html" rel="bookmark" class="title">HDU 1050-Moving Tables（水）</a>
					<div>
						Moving Tables Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) To ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38KvrW0.html" rel="bookmark" class="title">poj1236（强连通缩点）</a>
					<div>
						传送门:Network of Schools 题意:一些学校联接在一个计算机网络上,学校之间存在软件支援协议,每个学校都有它应支援的学校名单(A学校支援学校B,并不表示B学校一定支援学校A).当某校获 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
